 using UnityEngine;
using System.Linq;
using System.Collections.Generic;

namespace Weapons
{
	public class Weapons
	{
		public static void Main()
		{
		  CategoryBuilder.Create("Minecraft", "",ModAPI.LoadSprite("block.png"));  
            
        //Pillager
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Pillager -MCI",
                    NameToOrderByOverride = "AVP2",
                    DescriptionOverride = "Dwells near his outpost. Uses a crossbow as his weapon",
                    CategoryOverride = ModAPI.FindCategory("Minecraft"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnail/Pillager.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var skin = ModAPI.LoadTexture("Mobs/Pillager.png");
                        var flesh = ModAPI.LoadTexture("Mobs/Layer Flesh.png");
                        var bone = ModAPI.LoadTexture("Mobs/Layer Bone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 1);
                        foreach (var body in person.Limbs)
                        {
                            body.GetComponent<PhysicalBehaviour>().OverrideImpactSounds = new AudioClip[] 
                                {
                                    ModAPI.LoadSound("Sfx/Pillager.wav"),
                                    ModAPI.LoadSound("Sfx/Pillager2.wav"),
                                    ModAPI.LoadSound("Sfx/Pillager3.wav"),                                                                                
                                };
                             var ca = new GameObject("ca");
                             ca.transform.SetParent(Instance.transform.Find("Head"));
                             ca.transform.localPosition = new Vector3(0f, 0.18f);
                             ca.transform.localScale = new Vector3(1f, 1f);
                             var caSprite = ca.AddComponent<SpriteRenderer>();
                             caSprite.sprite = ModAPI.LoadSprite("Mobs/Illager Head.png"); 
                             ca.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";   

                             var car = new GameObject("car");
                             car.transform.SetParent(Instance.transform.Find("Head"));
                             car.transform.localPosition = new Vector3(0.17f, -0.08f);
                             car.transform.localScale = new Vector3(1f, 1f);
                             var carSprite = car.AddComponent<SpriteRenderer>();
                             carSprite.sprite = ModAPI.LoadSprite("Mobs/Illager Nose.png"); 
                             car.GetComponent<SpriteRenderer>().sortingLayerName = "Bubbles";                           
                        }
                    }
                }
            );
            //Pillager
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Vindicator -MCI",
                    NameToOrderByOverride = "AVP2",
                    DescriptionOverride = "A very strong illager. Uses an axe as his primary weapon",
                    CategoryOverride = ModAPI.FindCategory("Minecraft"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnail/Vindicator.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var skin = ModAPI.LoadTexture("Mobs/Vindicator.png");
                        var flesh = ModAPI.LoadTexture("Mobs/Layer Flesh.png");
                        var bone = ModAPI.LoadTexture("Mobs/Layer Bone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 1);
                        foreach (var body in person.Limbs)
                        {
                            body.GetComponent<PhysicalBehaviour>().OverrideImpactSounds = new AudioClip[] 
                                {
                                    ModAPI.LoadSound("Sfx/Vindicator.wav"),
                                    ModAPI.LoadSound("Sfx/Vindicator2.wav"),
                                    ModAPI.LoadSound("Sfx/Vindicator3.wav"),                                                                                
                                };
                             var ca = new GameObject("ca");
                             ca.transform.SetParent(Instance.transform.Find("Head"));
                             ca.transform.localPosition = new Vector3(0f, 0.18f);
                             ca.transform.localScale = new Vector3(1f, 1f);
                             var caSprite = ca.AddComponent<SpriteRenderer>();
                             caSprite.sprite = ModAPI.LoadSprite("Mobs/Illager Head.png"); 
                             ca.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";   

                             var car = new GameObject("car");
                             car.transform.SetParent(Instance.transform.Find("Head"));
                             car.transform.localPosition = new Vector3(0.17f, -0.08f);
                             car.transform.localScale = new Vector3(1f, 1f);
                             var carSprite = car.AddComponent<SpriteRenderer>();
                             carSprite.sprite = ModAPI.LoadSprite("Mobs/Illager Nose.png"); 
                             car.GetComponent<SpriteRenderer>().sortingLayerName = "Bubbles";                           
                        }
                    }
                }
            );
            //Pillager
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Evoker -MCI",
                    NameToOrderByOverride = "AVP2",
                    DescriptionOverride = "A magician, a wizard. Lives in a mansion in the dark forest. Uses magic to kill.",
                    CategoryOverride = ModAPI.FindCategory("Minecraft"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnail/Evoker.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var skin = ModAPI.LoadTexture("Mobs/Evoker.png");
                        var flesh = ModAPI.LoadTexture("Mobs/Layer Flesh.png");
                        var bone = ModAPI.LoadTexture("Mobs/Layer Bone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 1);
                        foreach (var body in person.Limbs)
                        {
                            body.GetComponent<PhysicalBehaviour>().OverrideImpactSounds = new AudioClip[] 
                                {
                                    ModAPI.LoadSound("Sfx/Evoker.wav"),
                                    ModAPI.LoadSound("Sfx/Evoker2.wav"),                                                                             
                                };
                             var ca = new GameObject("ca");
                             ca.transform.SetParent(Instance.transform.Find("Head"));
                             ca.transform.localPosition = new Vector3(0f, 0.18f);
                             ca.transform.localScale = new Vector3(1f, 1f);
                             var caSprite = ca.AddComponent<SpriteRenderer>();
                             caSprite.sprite = ModAPI.LoadSprite("Mobs/Illager Head.png"); 
                             ca.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";   

                             var car = new GameObject("car");
                             car.transform.SetParent(Instance.transform.Find("Head"));
                             car.transform.localPosition = new Vector3(0.17f, -0.08f);
                             car.transform.localScale = new Vector3(1f, 1f);
                             var carSprite = car.AddComponent<SpriteRenderer>();
                             carSprite.sprite = ModAPI.LoadSprite("Mobs/Illager Nose.png"); 
                             car.GetComponent<SpriteRenderer>().sortingLayerName = "Bubbles";                           
                        }
                    }
                }
            );
            //Pillager
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Illusioner -MCI",
                    NameToOrderByOverride = "AVP2",
                    DescriptionOverride = "The Mysterious Wizard. Appears occasionally in raids on villages. Uses a bow.",
                    CategoryOverride = ModAPI.FindCategory("Minecraft"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnail/Illusioner.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var skin = ModAPI.LoadTexture("Mobs/Illusioner.png");
                        var flesh = ModAPI.LoadTexture("Mobs/Layer Flesh.png");
                        var bone = ModAPI.LoadTexture("Mobs/Layer Bone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 1);
                        foreach (var body in person.Limbs)
                        {
                            body.GetComponent<PhysicalBehaviour>().OverrideImpactSounds = new AudioClip[] 
                                {
                                    ModAPI.LoadSound("Sfx/Illusioner.wav"),
                                    ModAPI.LoadSound("Sfx/Illusioner2.wav"),
                                    ModAPI.LoadSound("Sfx/Illusioner3.wav"),                                                                                
                                };
                             var ca = new GameObject("ca");
                             ca.transform.SetParent(Instance.transform.Find("Head"));
                             ca.transform.localPosition = new Vector3(0f, 0.18f);
                             ca.transform.localScale = new Vector3(1f, 1f);
                             var caSprite = ca.AddComponent<SpriteRenderer>();
                             caSprite.sprite = ModAPI.LoadSprite("Mobs/Illusioner Head.png"); 
                             ca.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";   

                             var car = new GameObject("car");
                             car.transform.SetParent(Instance.transform.Find("Head"));
                             car.transform.localPosition = new Vector3(0.17f, -0.08f);
                             car.transform.localScale = new Vector3(1f, 1f);
                             var carSprite = car.AddComponent<SpriteRenderer>();
                             carSprite.sprite = ModAPI.LoadSprite("Mobs/Illager Nose.png"); 
                             car.GetComponent<SpriteRenderer>().sortingLayerName = "Bubbles";                           
                        }
                    }
                }
            );
            //Pillager
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Illager -MCI",
                    NameToOrderByOverride = "AVP2",
                    DescriptionOverride = "Neutral Illager. He appears to be a worker.",
                    CategoryOverride = ModAPI.FindCategory("Minecraft"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnail/Illager.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var skin = ModAPI.LoadTexture("Mobs/Illager.png");
                        var flesh = ModAPI.LoadTexture("Mobs/Layer Flesh.png");
                        var bone = ModAPI.LoadTexture("Mobs/Layer Bone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 1);
                        foreach (var body in person.Limbs)
                        {
                            body.GetComponent<PhysicalBehaviour>().OverrideImpactSounds = new AudioClip[] 
                                {
                                    ModAPI.LoadSound("Sfx/Pillager.wav"),
                                    ModAPI.LoadSound("Sfx/Pillager2.wav"),
                                    ModAPI.LoadSound("Sfx/Pillager3.wav"),                                                                                
                                };
                             var ca = new GameObject("ca");
                             ca.transform.SetParent(Instance.transform.Find("Head"));
                             ca.transform.localPosition = new Vector3(0f, 0.18f);
                             ca.transform.localScale = new Vector3(1f, 1f);
                             var caSprite = ca.AddComponent<SpriteRenderer>();
                             caSprite.sprite = ModAPI.LoadSprite("Mobs/Illager Head.png"); 
                             ca.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";   

                             var car = new GameObject("car");
                             car.transform.SetParent(Instance.transform.Find("Head"));
                             car.transform.localPosition = new Vector3(0.17f, -0.08f);
                             car.transform.localScale = new Vector3(1f, 1f);
                             var carSprite = car.AddComponent<SpriteRenderer>();
                             carSprite.sprite = ModAPI.LoadSprite("Mobs/Illager Nose.png"); 
                             car.GetComponent<SpriteRenderer>().sortingLayerName = "Bubbles";                           
                        }
                    }
                }
            );
            //Pillager
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Illager 2 -MCI",
                    NameToOrderByOverride = "AVP2",
                    DescriptionOverride = "Neutral Illager. He also seems to be a worker.",
                    CategoryOverride = ModAPI.FindCategory("Minecraft"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnail/Illager 2.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var skin = ModAPI.LoadTexture("Mobs/Illager 2.png");
                        var flesh = ModAPI.LoadTexture("Mobs/Layer Flesh.png");
                        var bone = ModAPI.LoadTexture("Mobs/Layer Bone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 1);
                        foreach (var body in person.Limbs)
                        {
                            body.GetComponent<PhysicalBehaviour>().OverrideImpactSounds = new AudioClip[] 
                                {
                                    ModAPI.LoadSound("Sfx/Vindicator.wav"),
                                    ModAPI.LoadSound("Sfx/Vindicator2.wav"),
                                    ModAPI.LoadSound("Sfx/Vindicator3.wav"),                                                                                
                                };
                             var ca = new GameObject("ca");
                             ca.transform.SetParent(Instance.transform.Find("Head"));
                             ca.transform.localPosition = new Vector3(0f, 0.18f);
                             ca.transform.localScale = new Vector3(1f, 1f);
                             var caSprite = ca.AddComponent<SpriteRenderer>();
                             caSprite.sprite = ModAPI.LoadSprite("Mobs/Illager Head.png"); 
                             ca.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";   

                             var car = new GameObject("car");
                             car.transform.SetParent(Instance.transform.Find("Head"));
                             car.transform.localPosition = new Vector3(0.17f, -0.08f);
                             car.transform.localScale = new Vector3(1f, 1f);
                             var carSprite = car.AddComponent<SpriteRenderer>();
                             carSprite.sprite = ModAPI.LoadSprite("Mobs/Illager Nose.png"); 
                             car.GetComponent<SpriteRenderer>().sortingLayerName = "Bubbles";                           
                        }
                    }
                }
            );
            //Pillager
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Vex -MCI",
                    NameToOrderByOverride = "AVP2",
                    DescriptionOverride = "A small flying creature created by Evoker. Uses an iron sword.",
                    CategoryOverride = ModAPI.FindCategory("Minecraft"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnail/Vex.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var skin = ModAPI.LoadTexture("Mobs/Vex.png");
                        var flesh = ModAPI.LoadTexture("Mobs/Layer Flesh.png");
                        var bone = ModAPI.LoadTexture("Mobs/Layer Bone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 1);
                        foreach (var body in person.Limbs)
                        {
                            body.GetComponent<PhysicalBehaviour>().OverrideImpactSounds = new AudioClip[] 
                                {
                                    ModAPI.LoadSound("Sfx/Vex.mp3"),
                                    ModAPI.LoadSound("Sfx/Vex2.mp3"),                                                                               
                                };
                             var ca = new GameObject("ca");
                             ca.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody"));
                             ca.transform.localPosition = new Vector3(0f, 0.18f);
                             ca.transform.localScale = new Vector3(1f, 1f);
                             var caSprite = ca.AddComponent<SpriteRenderer>();
                             caSprite.sprite = ModAPI.LoadSprite("Mobs/Vex Wings.png"); 
                             ca.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";                              
                        }
                    }
                }
            );

            //Pillager
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"),
                    NameOverride = "Goat Horn -MCI",
                    NameToOrderByOverride = "AVP2",
                    DescriptionOverride = "Goat Horn Illagers Used to alert of danger, winnings, or anything else. Press F on the item to activate ",
                    CategoryOverride = ModAPI.FindCategory("Minecraft"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnail/Goat Horn.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite =  ModAPI.LoadSprite("Stuff/Goat Horn.png", 1f);
                        foreach (var c in Instance.GetComponents<Collider2D>())
						{
							GameObject.Destroy(c);
						}
						Instance.AddComponent<PolygonCollider2D>();
                        var AS = Instance.AddComponent<AudioSource>();
                        AS.priority = 10;
                        AS.volume = 10f;
                        AS.minDistance = 5f; 
                        AS.clip = ModAPI.LoadSound("Sfx/raidhorn_02.mp3");
                        Instance.AddComponent<UseEventTrigger>().Action = () =>
                        {
                            AS.Play();
                        };
                    }
                }
            );
            //Snowy Banner
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"), 
                    NameOverride = "Ominous Banner‌ -MCI",
                    NameToOrderByOverride = "EBannerVP2", 
                    DescriptionOverride = "Ominous Banner of the Illagers. Used to mark their territory",
                    CategoryOverride = ModAPI.FindCategory("Minecraft"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnail/Ominous Banner‌.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Stuff/Ominous Banner‌.png", 0.7f);
						Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Soft");
						foreach (var c in Instance.GetComponents<Collider2D>())
              				{ 
                     			GameObject.Destroy(c);
              				}
              			Instance.AddComponent<BoxCollider2D>();
                        Instance.FixColliders();  
                    }
                }
            ); 

		}
	}
	
	public class BurstFireAdapter : MonoBehaviour
	{
		public float Interval = 0.1f;
		public int BurstCount = 5;

		private bool busy = false;

		private CanShoot firearm;

		private void Awake()
		{
			firearm = GetComponent<CanShoot>();
		}

		private void Use()
		{
			StartCoroutine(Burst());
		}

		private System.Collections.IEnumerator Burst()
		{
			if (busy) yield break;
			busy = true;
			for (int i = 0; i < BurstCount - 1; i++)
			{
				yield return new WaitForSeconds(Interval);
				firearm.Shoot();
			}
			busy = false;
		}
	} 
}   